//+------------------------------------------------------------------+
//|                                                  GoodGrid_v1_1.mq4 |
//|                                         Copyright  2007, spence |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, spence"
#property link      "mailto:spikai@freenet.de?subject=EXPERT_ADVISOR_GoodGrid_v1_1"


extern int     step              = 10;     //space between the positions in pips
extern int     pos               = 24;     //how much positions should be opened in both direction max. 50. it could be limited by broker
                                           //and shouldn't be more than broker allows ---> if it's more the EA crashes
                                           //ex. 24 are 12buy and 12sell 
extern int     Slippage          = 2;
extern double  LotsBeginning     = 0.2;   //for ex. first order 0.2 second 0.4 third 0.6 ... 


int     TakeProfit        = 999;   //normal TakeProfit limited by broker
int     StopLoss          = 999;   //normal StopLoss limited by broker
//extern int     spread            = 3;     //spread  of used pair
//extern int     TakeSmallProfit   = 0;     //coded TakeProfit - could be 1pip or more
//extern int     StopSmallLoss     = 0;     //coded StopLoss - could be 1pip or more

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

//open orders *************************************************************************************


int total = OrdersTotal();                       
if (total<1)
   {
      int k = 1;
      while(k<=pos) 
         {
            int ticket=OrderSend(Symbol(),OP_BUY,LotsBeginning*k,Ask,Slippage*Point,Ask-StopLoss*Point,Ask+TakeProfit*Point,"GoodGrid_v1", 99999,0,Green);
            static int longarray[50];            
            if(ticket>0)
               {
                  if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                     {
                        longarray[k]=ticket;                       
                        Print("BUY order opened : ",OrderOpenPrice(),"  ",OrderTicket());
                     }
                  else return(0);//Print("Error opening BUY order : ",GetLastError());
                       
               }
           
            ticket=OrderSend(Symbol(),OP_SELL,LotsBeginning*k,Bid,Slippage*Point,Bid+StopLoss*Point,Bid-TakeProfit*Point,"GoodGrid_v1", 99999,0,Red);
            static int shortarray[50];
            
            if(ticket>0)
               {
                  if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                     {
                        shortarray[k]=ticket;
                        Print("SELL order opened : ",OrderOpenPrice(),"  ",OrderTicket());
                     }
                  else return(0);//Print("Error opening SELL order : ",GetLastError());
                       
               }   
          k++;                                     
         }
   }


//close orders *************************************************************************************
total = OrdersTotal();                       
if (total>=1)
   {
      k = 1;
      while(k<=pos/2) 
         { 
            int c=pos/2+1-k;
            
            OrderSelect(longarray[k],SELECT_BY_TICKET,MODE_TRADES); //select long position              
               if(OrderCloseTime()==0 && OrderOpenTime()>0)
                  {
                     // check for TakeSmallProfit and close the opposite position if position is takeprofit
                     if(Bid-OrderOpenPrice()>= Point*(step*k))
                        {
                           OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);                                                                      
                           OrderSelect(shortarray[c],SELECT_BY_TICKET,MODE_TRADES); //select short position  
                           OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Blue);                                          
                        }                   
                  }
            k++;         
         }
         
      k = 1;
      while(k<=pos/2) 
         { 
            c=pos/2+1-k;             
                  
            OrderSelect(shortarray[k],SELECT_BY_TICKET,MODE_TRADES); //select short position           
               if(OrderCloseTime()==0 && OrderOpenTime()>0)
                  {
                     // check for TakeSmallProfit and close the opposite position if position is takeprofit
                     if(OrderOpenPrice()-Ask>= Point*(step*k))
                        {
                           OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Blue);
                           OrderSelect(longarray[c],SELECT_BY_TICKET,MODE_TRADES); //select long position 
                           OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);                
                        }
                  }

            k++; 
         }
   }
   
   






   
//----
   return(0);
  }
//+------------------------------------------------------------------+